package Time::OO::Day;
use strict;
use vars qw($VERSION @ISA);
use Time::OO::ModuleCalc;
@ISA = ("Time::OO::ModuleCalc");
$VERSION = sprintf("%d.%d.%d", q$Revision: 1.0.0 $ =~ /(\d+)\.(\d+)\.(\d+)/);


sub init {
    my $self = shift();

    print STDERR "FIXME: limit in Day.pm\n";
    $self->{'limit'} = 31;
    $self->{'upper'} = "month";
    $self->{'days_sum'} = {
	'normal' => [0, 31, 59, 90, 120, 151, 181, 212, 243, 273, 304, 334,
		     365],
	'leap'   => [0, 31, 60, 91, 121, 152, 182, 213, 244, 274, 305, 335,
		     366],
    };
}


sub seconds {
    return(86400);
}


sub minutes {
    return(1440);
}


sub hours {
    return(24);
}


sub of_week {
    my $self = shift();
 
    my $dow = 0;
    my $week = $self->time->month->which();
    if ($self->time->year->is_leapyear()) {
        $dow = $self->{'days_sum'}->{'leap'}->[$week-2] + $self->{'day'};
    } else {
        $dow = $self->{'days_sum'}->{'normal'}->[$week-2] + $self->{'day'};
    }
    return($dow);
}


sub of_year {
    my $self = shift();
 
    my $days = 0;
    my $month = $self->time->month->which();
    if ($self->time->year->is_leapyear()) {
        $days = $self->{'days_sum'}->{'leap'}->[$month-2] + $self->{'day'};
    } else {
        $days = $self->{'days_sum'}->{'normal'}->[$month-2] + $self->{'day'};
    }
    return($days);
}


sub remaining {
    my $self = shift();
    return($self->time->month->days() - $self->{'value'});
}


1;
