package Time::OO::ModuleCalc;
use strict;


sub new {
    my $class = shift();
    my $time = shift();

    my $self = {
        'time' => $time,
    };
    bless($self, $class);
    $self->init() if ($self->can("init"));
    return($self);
}

sub time      {  return($_[0]->{'time'})      };

sub normalize {
    my $self = shift();
    my $much = shift();
    my $limit = shift() || $self->{'limit'};
    my $upper = shift() || $self->{'upper'};

    if ($much >= $limit) {
#	print "upper1: $upper $limit $amuch\n";
	$self->time->$upper->forward( int($much/$limit) );
	$much = ($much % $limit);
    } elsif ($much < 0) {
#	print "upper2: $upper much: $much $limit $amuch\n";
	$self->time->$upper->forward( int($much/$limit)-1 );
#	print "much: $much ($limit-($much % $limit)-1)\n";
#	$much = ($limit-($much % $limit)-1);
	$much = ($much % $limit);
    }
#    print "much: $much $upper\n";
    return($much);
}


sub forward {
    my $self = shift();
    my $much = shift();

    $self->{'value'} = $self->normalize( ($much + $self->{'value'}) );
}


sub value {
    my $self = shift();
    my $value = shift();

    if (defined($value)) {
	$self->{'value'} = $value;
    } else {
	return($self->{'value'});
    }
}


sub backward {
    my $self = shift();
    my $much = shift();

    return($self->forward(-$much));
}


sub remaining {
    my $self = shift();
    return($self->{'limit'} - $self->{'value'});
}


sub next {
    my $self = shift();
    $self->forward(1);
}


sub former {
    my $self = shift();
    $self->backward(1);
}


1;
