package Time::OO::Month;
use strict;
use vars qw($VERSION @ISA);
use Time::OO::ModuleCalc;
@ISA = ("Time::OO::ModuleCalc");
$VERSION = sprintf("%d.%d.%d", q$Revision: 1.0.0 $ =~ /(\d+)\.(\d+)\.(\d+)/);


sub init {
    my $self = shift();

    $self->{'limit'} = 12;
    $self->{'upper'} = "year";
    $self->{'days'} = {
	'normal' => [31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31, 31],
	'leap'   => [31, 29, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31, 31],
    };
}


sub seconds {
    my $self = shift();
    return($self->days()*86400);
}


sub minutes {
    my $self = shift();
    return($self->days()*1440);
}


sub hours {
    my $self = shift();
    return($self->days()*24);
}


sub days {
    my $self = shift();
    
    my $days = 0;
    if ($self->time->year->is_leapyear()) {
	$days = $self->{'days'}->{'leap'}->[$self->{'value'}-1];
    } else {
	$days = $self->{'days'}->{'normal'}->[$self->{'value'}-1];
    }
    return($days);
}


1;
