######################################################################

package FReDI::SymbolicTimeRange;
use strict;
use vars qw($VERSION);
$VERSION = sprintf("%d.%d.%d", q$Revision: 1.0.0 $ =~ /(\d+)\.(\d+)\.(\d+)/);
my $symbols = {
    'gestern' => 'yesterday',
#Xdaysbefore
#Xdaysahead
    'yesterday' => [2, -86400,86399],
    'today'     => [2,      0,86399],
    'tomorrow'  => [2,  86400,86399],
    'nextweek'  => [2, -86400,86399],
    'thisweek'  => [2,      0,86399],
    'lastweek'  => [2,  86400,86399],
};

sub new {
    my $class = shift();

    my $self = {};
    bless($self, $class);
    return($self);
}


sub ranges {
    my $self = shift();
    my @t = (0, 0);

    # 01.01.2001->absolut
    # todayX->relativ

    return(@t);
}

sub t0 {
    my $self = shift();
    my $type = shift();

    my $t0 = 0;
    if ($type eq "second") {
    } elsif ($type eq "minute") {
    } elsif ($type eq "hour") {
    } elsif ($type eq "day") {
    } elsif ($type eq "week") {
    } elsif ($type eq "month") {
    } elsif ($type eq "year") {
    } elsif ($type eq "decade") {
    } elsif ($type eq "century") {
    } elsif ($type eq "millenium") {
    } else {
	warn("Unknown type $type in t0 (class".ref($self).")");
    }

    return($t0);
}


sub t_offset {
    my $self = shift();
    my $offset = shift();

    my $t_offset = 0;
    if ($type eq "second") {
	$t_offset = 1;
    } elsif ($type eq "minute") {
	$t_offset = 60;
    } elsif ($type eq "hour") {
	$t_offset = 3600;
    } elsif ($type eq "day") {
	$t_offset = 86400;
    } elsif ($type eq "week") {
	$t_offset = (7*86400);
    } elsif ($type eq "month") {
	$t_offset = 0;
    } elsif ($type eq "year") {
    } elsif ($type eq "decade") {
    } elsif ($type eq "century") {
    } elsif ($type eq "millenium") {
    } else {
	warn("Unknown type $type in t_offset (class".ref($self).")");
    }
    $t_offset -= 1;
    return($t_offset);
}



		if ($skeleton->{$searchfield}{'type'} eq "date") {
		    my ($t_start, $t_end, $today);
		    my ($t_sec,$t_min,$t_hour,$t_mday,$t_mon,$t_year,
			$t_wday,$t_yday,$t_isdst);
		    my $now = time();
		    $now -= 61200 if ($db_name eq "sternzeit");
		    unless ($pattern =~ m/^\d/) {
			($t_sec,$t_min,$t_hour,$t_mday,$t_mon,$t_year,
			 $t_wday,$t_yday,$t_isdst) = localtime($now);

			$today = $now-($t_hour*3600+$t_min*60+$t_sec);
			my $thisyear = $today - ($t_yday*86400);
#			if ($db_name eq "") {
#			    $today += 27000;
#			}

			if ($pattern eq "yesterday" || $pattern eq "gestern") {
			    $t_end = $today;
			    $t_start = $t_end-86400;
			    $t_end -= 1;
			    $show_details = 1;
			} elsif ($pattern eq "today" || $pattern eq "heute") {
			    $t_start = $today;
			    $t_end = $t_start+86400-1;
			    $show_details = 1;
			} elsif ($pattern eq "tomorrow" || $pattern eq "morgen") {
			    $t_start = $today+86400;
			    $t_end = $t_start + 86400-1;
			    $show_details = 1;


			} elsif ($pattern eq "lastweek") {
			    $t_end = $today-$t_wday*86400;
			    $t_start = $t_end-7*86400;
			    $t_end -= 1;
			    $show_details = 1;
			} elsif ($pattern eq "thisweek") {
			    $t_start = $today-$t_wday*86400;
			    $t_end = $t_start+8*86400-1;
			    $show_details = 1;
			} elsif ($pattern eq "nextweek" ) {
			    $t_start = $today+(7-$t_wday)*86400;
			    $t_end = $t_start + 8*86400-1;
			    $show_details = 1;


 			} elsif ($pattern =~ m/^last(\d+)days$/) {
			    my $range = $1;
			    if ($range > 4) {
				$template = $old_template;
			    }
			    $t_end = $today+86400;
			    $t_start = $t_end - $range*86400;
			    $t_end -= 1;
			    $show_details = 1;
			} elsif ($pattern =~ m/^next(\d+)days$/) {
			    my $range = $1;
                            if ($range > 4) {
                                $template = $old_template;
                            }
			    $t_start = $today;
			    $t_end = $t_start + $range*86400-1;
			    $show_details = 1;

			} elsif ($pattern eq "lastmonth") {
			    $template = $old_template;
			    my $as = sprintf("%02d", $t_mon);
			    $t_start = $thisyear + $days{$as}*86400;
			    $as = sprintf("%02d", $t_mon+1);
			    $t_end = $thisyear + $days{$as}*86400-1;
			    $t_start = $t_end-31*86400;
			    $t_end -= 1;

			} elsif ($pattern eq "thismonth") {
			    $template = $old_template;

			    my $as = sprintf("%02d", $t_mon+1);
			    $t_start = $thisyear + $days{$as}*86400;
			    $as = sprintf("%02d", $t_mon+2);
			    $t_end = $thisyear + $days{$as}*86400-1;
			} elsif ($pattern eq "nextmonth") {
			    $template = $old_template;

			    my $as = sprintf("%02d", $t_mon+2);
			    $t_start = $thisyear + $days{$as}*86400;
			    $as = sprintf("%02d", $t_mon+3);
			    $t_end = $thisyear + $days{$as}*86400-1;

			} elsif ($pattern eq "thisyear") {
			    $template = $old_template;
			    $t_start = $today-($t_yday-1)*86400;
			    $t_end = $t_start+365*86400;

			} elsif ($pattern =~ m/^kw_(\d+)$/) {
			    my $kw = $1;
			    if ($kw < 0) {
				$kw = 0;
			    }
			    if ($kw > 53) {
				$kw = 53;
			    }
			    my $kw_offset = (localtime($today - (86400*($t_yday-1))))[6];
			    my $ws = 2;
			    if ($kw_offset > 0 && $kw_offset < 5) {
				$ws = 1;
			    }
			    $kw_offset = 8-$kw_offset;

			    $t_start = $today;
			    $t_start += (7*($kw-$ws) +$kw_offset -$t_yday +1)*86400;
			    if ($t_start < ($today-($t_wday*86400)-7*86400)) {
				$t_start += 365*86400;
			    }
			    $t_end = $t_start + 7*86400 -1;
			    $show_details = 1;

			} else {
			    my @months=("jan", "feb",
					"m(|a)r", "apr", "ma(i|y)",
					"jun", "jul", "aug", "sep", "o(c|k)t",
					"nov", "de(c|z)");
			    my $i=0;
			    for (@months) {
				$i++;
				if ($pattern =~ m/^$_/i) {
				    last;
				}
			    }
                            if ($i<12) {
                                my $month = sprintf("%02d", $i);
                                $t_start = $today - ($t_yday+1)*86400 + $days{$month}*86400;
                                $month = $month + 0;
                                $t_end = $t_start + ($dpm[$month]+1)*86400;
                                if ($i<$t_mon) {
                                    $t_start += 365*86400;
                                    $t_end += 365*86400;
                                }
                                $template = $old_template;
                            }

			}
			$query->{'t_start'} = $t_start;
			$query->{'t_end'}   = $t_end;
		    } else {
			unless ($pattern =~ m/\./) {
			    if ($query->{'t_start'} == 0) {
				($t_sec,$t_min,$t_hour,$t_mday,$t_mon,$t_year,
				 $t_wday,$t_yday,$t_isdst) = localtime($now);
				$today = $now-($t_hour*3600+$t_min*60+$t_sec-1);
				$query->{'t_start'} = $today - ($t_mday-1)*86400;
				if ($pattern < $t_mday) {
				    $query->{'t_start'} += $dpm[$t_mon] * 86400;
				}
			    }
			    $query->{'t_start'} += ($pattern-1) * 86400 +3600;
			    $query->{'t_end'} = $query->{'t_start'}+86400-100;			
			} else {
			    $pattern =~ m/^\s*(\d+)\s*\.\s*(\d+)\s*\.\s*(\d*)/;
			    my $day = $1;
			    $day = 1 if ($day < 1);
			    $day = 31 if ($day > 31);
			    my $month = $2;
			    $month = 1 if($month < 1);
			    $month = 12 if($month > 12);
			    my $year = $3;
			    if ($year == 0) {
				$year = 1900 + (localtime($now))[5];
			    }
			    if ($year < 100) {
				$year += 1900;
			    }
			    $month -= 1;
			    $query->{'t_start'} = timelocal(0,0,0, $day, $month, $year);
			    $query->{'t_end'} = $query->{'t_start'}+86300;
			}
			$show_details = 1;
		    }
		} else {
		    $query->{$searchfield} = $pattern;
		}
	    }
#FIXME: pat pattern auf den Typ? Sind alle Typen suchbar? (URL, usw.)
#FIXME: pattern in eine suchbare Form wandeln		

	}
	
